<template>
  <div class="subscription-column__points">
    <div
      v-if="items.length"
      class="subscription-column__points-items"
    >
      <Tab
        v-for="item in itemsVisible"
        :key="item.uuid"
        :name="item.title"
        :icon="'truck-sm'"
        :toggle="toggle"
        @click="remove(item)"
      />

      <button
          v-if="itemsHidden.length"
          class="button"
          @click="showOtherItems('show')"
      >
        еще {{ itemsHidden.length }}
      </button>
      <button
          v-if="limit > 10"
          class="button"
          @click="showOtherItems('hide')"
      >
        скрыть
      </button>
    </div>
    <div
      v-else
      class="subscription-column__points-empty"
    >
      -
    </div>
  </div>
</template>

<script>
  import Tab from './tab';
  import { mapGetters } from "vuex";
  import cloneDeep from 'clone-deep';
  export default {
    name: 'ServicePoints',
    components: {
      Tab,
    },
    props: {
      serviceUuid: {
        type: String,
        default: ''
      },
      subscription: {
        type: Object,
        default: () => {}
      },
      toggle: {
        type: Boolean,
        default: true
      }
    },
    data() {
      return {
        limit: 10
      }
    },
    computed: {
      ...mapGetters({
        listServices: 'subscriptions/services'
      }),
      items () {
        const commonListByCell = this.subscription.services.find(key => key.serviceTypeUuid === this.serviceUuid);
        let data = [];
        if (commonListByCell) {
          const service = this.listServices.find(key => key.uuid === commonListByCell.serviceTypeUuid);

          const sortGroupsByService = service.list.reduce((array, value) => {
            const anchor = value.resourceSubtypeUuid;
            if (anchor in array) {
              array[anchor].push(value)
            } else {
              array[anchor] = [value]
            }
            return array
          }, {});

          if (commonListByCell.isAll) {
            data = Object.values(sortGroupsByService).reduce((array, value) => {
              array.push({
                title: value[0].resourceSubtypeTitle,
                uuid: value[0].resourceSubtypeUuid,
                group: value
              });
              return array;
            }, []);
          } else {
            const listUuid = commonListByCell.serviceUuids.map(key => key);
            const findServiceByUuidAndSortingByGroup = service.list.reduce((array,value) => {
              listUuid.forEach(item => {
                if (item === value.uuid) {
                  const anchor = value.resourceSubtypeUuid;
                  if (anchor in array) {
                    array[anchor].push(value)
                  } else {
                    array[anchor] = [value]
                  }
                }
              });
              return array;
            }, {});

            data = Object.entries(findServiceByUuidAndSortingByGroup).reduce((array, value) => {
              Object.entries(sortGroupsByService).forEach((key) => {
                if (value[0] === key[0]) {
                  if (key[1].length === value[1].length) {
                    array.push({
                      title: value[1][0].resourceSubtypeTitle,
                      uuid: value[1][0].resourceSubtypeUuid,
                      group: value[1]
                    });
                  } else {
                    array.push(...value[1]);
                  }
                }
              });
              return array;
            }, []);
          }
        }
        return data;
      },
      itemsVisible() {
        return this.items.slice(0, this.limit);
      },
      itemsHidden() {
        if (this.items.length === this.itemsVisible.length) {
          return [];
        }
        return this.items.slice(10, this.items.length);
      },
    },
    methods: {
      remove (item) {
        const data = cloneDeep(this.items);
        const index = data.findIndex(key => key.uuid === item.uuid);
        if (index !== -1) {
          data.splice(index, 1);
          this.$emit('delete', {
            service: data,
            serviceUuid: this.serviceUuid,
            subscription: this.subscription
          })
        }
      },
      showOtherItems (type) {
        if (type === 'show') {
          this.limit = this.items.length
        } else{
          this.limit = 10
        }
      }
    }
  };
</script>
